# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetRegistrarDomainResult',
    'AwaitableGetRegistrarDomainResult',
    'get_registrar_domain',
    'get_registrar_domain_output',
]

@pulumi.output_type
class GetRegistrarDomainResult:
    """
    A collection of values returned by getRegistrarDomain.
    """
    def __init__(__self__, account_id=None, domain_name=None, id=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if domain_name and not isinstance(domain_name, str):
            raise TypeError("Expected argument 'domain_name' to be a str")
        pulumi.set(__self__, "domain_name", domain_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> builtins.str:
        """
        Identifier
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="domainName")
    def domain_name(self) -> builtins.str:
        """
        Domain name.
        """
        return pulumi.get(self, "domain_name")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetRegistrarDomainResult(GetRegistrarDomainResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRegistrarDomainResult(
            account_id=self.account_id,
            domain_name=self.domain_name,
            id=self.id)


def get_registrar_domain(account_id: Optional[builtins.str] = None,
                         domain_name: Optional[builtins.str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRegistrarDomainResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_registrar_domain = cloudflare.get_registrar_domain(account_id="023e105f4ecef8ad9ca31a8372d0c353",
        domain_name="cloudflare.com")
    ```


    :param builtins.str account_id: Identifier
    :param builtins.str domain_name: Domain name.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['domainName'] = domain_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getRegistrarDomain:getRegistrarDomain', __args__, opts=opts, typ=GetRegistrarDomainResult).value

    return AwaitableGetRegistrarDomainResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        domain_name=pulumi.get(__ret__, 'domain_name'),
        id=pulumi.get(__ret__, 'id'))
def get_registrar_domain_output(account_id: Optional[pulumi.Input[builtins.str]] = None,
                                domain_name: Optional[pulumi.Input[builtins.str]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRegistrarDomainResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_registrar_domain = cloudflare.get_registrar_domain(account_id="023e105f4ecef8ad9ca31a8372d0c353",
        domain_name="cloudflare.com")
    ```


    :param builtins.str account_id: Identifier
    :param builtins.str domain_name: Domain name.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['domainName'] = domain_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getRegistrarDomain:getRegistrarDomain', __args__, opts=opts, typ=GetRegistrarDomainResult)
    return __ret__.apply(lambda __response__: GetRegistrarDomainResult(
        account_id=pulumi.get(__response__, 'account_id'),
        domain_name=pulumi.get(__response__, 'domain_name'),
        id=pulumi.get(__response__, 'id')))
